<template lang="pug">
    div
        div#map
        link(rel="stylesheet" href="https://unpkg.com/leaflet@1.6.0/dist/leaflet.css"
            integrity="sha512-xwE/Az9zrjBIphAcBb3F6JVqxf46+CDLwfLMHloNu6KEQCAWi6HcDUbeOfBIptF7tcCzusKFjFw2yuvEpDL9wQ=="
            crossorigin=""
        )
        v-btn(
            color="primary"
            @click="update"
        ) Update
</template>

<script>
import L from "leaflet";

export default {
    name: "gis-map",
    props: {
        gis: {
            type: Array,
            required: false,
            default: () => []
        }
    },
    data() {
        return {
            map: null
        };
    },
    mounted() {
        this.map = L.map("map").setView(
            [-1.99870001632014, 53.5058606499777],
            13
        );
        L.tileLayer(
            "https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token={accessToken}",
            {
                attribution: `Map data &copy; <a href='https://www.openstreetmap.org/'>OpenStreetMap</a>
            contributors,
            <a href='https://creativecommons.org/licence/by-sa/2.0">CC-BY-SA</a>, Imagery &copy;
            <a href='https://www.mapbox.com/'>Mapbox</a>`,
                maxZoom: 18,
                id: "mapbox/streets-v11",
                accessToken:
                    "pk.eyJ1Ijoic3Rpdm5jIiwiYSI6ImNrM3hkM291djBwMXYzanA3NHQ5M3N4MXgifQ.gkC67XiuuON-0nuAjjDj8w"
            }
        ).addTo(this.map);
    },
    computed: {
        getGeoJson() {
            return this.gis.map(el => {
                return {
                    type: "Feature",
                    properties: el.attributes,
                    geometry: JSON.parse(el.attributes.geometry)
                };
            });
        }
    },
    methods: {
        update() {
            L.geoJSON(this.getGeoJson).addTo(this.map);
        }
    }
};
</script>

<style>
#map {
    height: 180px;
}
</style>
